library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- in  Clock: 33 Mhz
-- out Clock: 1 MHz
entity CLKDIV is
   Port ( clk			: in	STD_LOGIC;
			 rst		: in	STD_LOGIC;
          clk_out		: out	STD_LOGIC);            
end CLKDIV;

architecture clk_bhv of CLKDIV is     
	signal clks  	:	std_logic;
	signal counter	:	std_logic_vector(11 downto 0);
	-- counter variable invece che signals?
begin
	process (clk)
	begin
		if (rst = '0') then
			clks <= '0';
			counter <= "000000000000";
		elsif rising_edge(clk) then
			counter <= counter + '1';
			if (counter = "111111111111") then  -- 33 / (4095*2) = 4 KHz
				counter <= "000000000000";    	-- Divido ulteriormente per due perchè
												-- commuto solo sul fronte di salita
				clks <= not clks;
			end if;
		end if;
	end process;
	clk_out <= clks;
end clk_bhv;